import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
class LocalResolver implements org.xml.sax.EntityResolver {
    public LocalResolver(){}
    public InputSource resolveEntity(String publicID, String systemID){
	return new InputSource(systemID.replaceAll("[^/]*/",""));
    }
}
class Mokuji {
    private static void printMokuji(Node node){
	String name = node.getNodeName();
	if(name.matches("h[1-6]")){
	    for(int i=0; i<name.charAt(1)-'1'; i++){
		System.out.print(' ');
	    }
	    System.out.println(node.getTextContent());
	}
	NodeList nl = node.getChildNodes();
	for(int i=0; i<nl.getLength(); i++){
	    printMokuji(nl.item(i));
	}
    }
    public static void main(String[] args) throws Exception {
	File f = new File(args[0]);
	DocumentBuilderFactory dbf=DocumentBuilderFactory.newInstance();
	DocumentBuilder db= dbf.newDocumentBuilder();
	db.setEntityResolver(new LocalResolver()); //*
	Document doc = db.parse(f);
	printMokuji(doc);
    }
}
